//
// stund/util.cxx
// 
// Copyright (c) 2002 Alan Hawrylyshen
// 
// Permission is hereby granted, free of charge, to any person obtaining
// a copy of this software and associated documentation files (the
// "Software"), to deal in the Software without restriction, including
// without limitation the rights to use, copy, modify, merge, publish,
// distribute, sublicense, and/or sell copies of the Software, and to
// permit persons to whom the Software is furnished to do so, subject to
// the following conditions:
// 
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
// IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
// CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
// TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
// SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
//

#include <iostream.h>
#include <string.h>
#include <ctype.h>

#include "util.h"


#if defined(WIN32) || defined(sun)

char *optarg = 0;
int optind = 0;

/**
 * This is a very hacked version for WIN32 that will support only what
 * we need.  This is NOT a generic getopt_long()
 */
 int local_getopt_long(int argc,	
		 char * const argv[],
		 const char *optstring,
		 const struct option *longopts,
		 int *longindex			
		 )
{
  static int carg = 0;
  //static int nextchar = 0;
  
  carg++;
  if ( carg >= argc ) return -1;

  char * p = argv[carg];
  //register int al = strlen(argv[carg]);

  if (*p  == '-' && isalnum(*(p+1)))
  {
    char o = *(p+1);

    register int l = strlen(optstring);

    for(register int i = 0 ; i < l; i++)
    {

      if (optstring[i] == ':') continue;

      if ( optstring[i] == o )	// match option char
      {
	
	if ( optstring[i+1] == ':' ) // arg option
	{
	  optind = ++carg;
	  optarg = argv[optind];

	}
	else
	{
	  optind = 0;
	  optarg = 0;
	}
	return (int)o;
      }

    }

    return (int)'?';
  }
  return (int)'?';
}
#else
 
int local_getopt_long(int argc,	
		 char * const argv[],
		 const char *optstring,
		 const struct option *longopts,
		 int *longindex			
		 )
{
   return getopt_long(argc,argv,optstring,longopts,longindex);
}

#endif


// Local Variables:
// mode:c++
// c-file-style:"ellemtel"
// c-file-offsets:((case-label . +))
// indent-tabs-mode:nil
// End:


