//
// stund/util.h
// 
// Copyright (c) 2002 Alan Hawrylyshen
// 
// Permission is hereby granted, free of charge, to any person obtaining
// a copy of this software and associated documentation files (the
// "Software"), to deal in the Software without restriction, including
// without limitation the rights to use, copy, modify, merge, publish,
// distribute, sublicense, and/or sell copies of the Software, and to
// permit persons to whom the Software is furnished to do so, subject to
// the following conditions:
// 
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
// IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
// CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
// TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
// SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
//
#ifndef __UTIL_H
#define __UTIL_H

#if defined (sun) || defined (WIN32)
extern int optind;
extern char *optarg;

struct option
{
  const char *name;
  int has_arg;
  int *flag;
  int val;
};
#endif


/**
  Implementation of getopt_long(3) for Windows and Solaris.
  This version is VERY stupid
  and assumes that the options are passed in a [-x y] format where x is
  a single character and y is the value.  No other fancy smancy stuff is
  supported.
  @param argc Number of command line args.
  @param argv Vector of command line args.
  @param optstring A single character option string (list).
  @param longopts The long-style options (unsupported in Win32 environment)
  @param longindex The index into @{link longopts longopts}.
*/
 int local_getopt_long( int argc,	
		 char * const argv[],
		 const char *optstring,
		 const struct option *longopts,
		 int *longindex
		 );

#if defined(linux)
#include <unistd.h>
#define _GNU_SOURCE
#include <getopt.h>
#endif

#endif
